/*************************************************************************
 **                            PSClass.h                                **
 *************************************************************************
 ** a simple C++ container for the lower (or is it upper?) portion of   **
 ** the Performer scenegraph & some attributes.                         **
 *************************************************************************/
#ifndef _PSClass_h_
#define _PSClass_h_

#include <Performer/pf/pfChannel.h>
#include <Performer/pf/pfLightSource.h>
#include <Performer/pf/pfGroup.h>
#include <Performer/pf.h>
#include <Performer/pf/pfTraverser.h>
#include <Performer/pfdu.h>

const int _PSC_MAX_LIGHTS = 5;

class PSClass
{
public:
	// constructor
	PSClass(int argc, char **argv);

	int configScene(int numLights=2,
	                float * pos=NULL,
	                float * amb_color=NULL);

	inline pfScene * getScene()            { return _scene; } 
	inline pfGroup * getGroup()            { return _grp;   }

private:
	float idx, idy, idz; // initial displacement if navdcs
	pfGroup * _grp;
	pfScene * _scene;
	pfLightSource * lt[_PSC_MAX_LIGHTS];
};

#endif

