/**********************************************************************
 **                          caveNav.c++                             **
 **********************************************************************
 ** simple CAVE navigation class                                     **
 **********************************************************************/
#include "caveNav.h"

// navigate() 
void
caveNav::navigate()
{
	// Do normal CAVE navigation
	_jx=-CAVE_JOYSTICK_X;
	_jy= CAVE_JOYSTICK_Y;

	if (_first) {
		CAVENavTranslate(_iDx, _iDy, _iDz);
		_first = False;
	}

	if (fabs(_jy) > _jPad || fabs(_jx) > _jPad) {
		CAVENavRot(_rSpeed * _jx,'z');
		CAVEGetVector(CAVE_WAND_FRONT,_wv);
		CAVENavTranslate(_wv[0] * _jy * _tSpeed,
		                 _wv[1] * _jy * _tSpeed,
		                 _wv[2] * _jy * _tSpeed);
	}

	/*Store the CAVE navigation in the DCS */
	pfCAVEDCSNavTransform(_navDCS);
}

