/*************************************************************************
 **                          happySphere.h                              **
 *************************************************************************
 ** sphere class for illustration purposes.                             **
 ** Author: Fred Dech                                                   **
 ** (C) 2001 Virtual Reality in Medicine Laboratory                     **
 **          University of Illinois at Chicago                          **
 *************************************************************************/

#include "happySphere.h"

/////// Happy Sphere Singleton Class ////////
happySphere * happySphere::_instance = NULL;

// constructor  we only need one of these happy shpheres.
happySphere::happySphere()
{
	pfNode *obj;

	pfFilePath("./models/");

	if (obj = pfdLoadFile("fredsphere.iv")) {
		_dcs1 = new pfDCS;
		_dcs2 = new pfDCS;

		_dcs2->addChild(obj);
		_dcs1->addChild(_dcs2);

		_dcs1->setTrans(0.0, 5.0, 0.0);

		// we don't want intersecton traversal on either sphere pfDCS.
		_dcs1->setTravMask(PFTRAV_ISECT, 0x0, PFTRAV_SELF, PF_SET);
		_dcs2->setTravMask(PFTRAV_ISECT, 0x0, PFTRAV_SELF, PF_SET);

	} else {
		fprintf(stderr, "Couldn't Load GEOM fredsphere.iv:  Exiting\n");
		exit(0);
	}
}

