/*************************************************************************
 **                           myObserv.h                                **
 *************************************************************************
 ** This concrete Observer acts as a conduit between the cncreteMed     **
 ** GUI interface and other parts of the application                    **
 ** Author: Fred Dech                                                   **
 ** (C) 2000 Virtual Reality in Medicine Laboratory                     **
 **          University of Illinois at Chicago                          **
 *************************************************************************/

#ifndef _myObserv_h_
#define _myObserv_h_

#include <Performer/pf.h>
#include <Performer/pf/pfDCS.h>
#include <vwMediator.h>
#include <vwButton.h>
#include "happySphere.h"

class myObserv : public vwObserver
{
protected:
	myObserv(vwMediator *);

public:
	virtual ~myObserv() { }

    // singleton method
    static myObserv * instance(vwMediator *);

	// override pure virtual from abstract vwObserver class
	void update(vwSubject *, void *);
	float getSliderVal()     { return _yRot; }

private:
	static myObserv * _instance;

	happySphere * _sphere;

	float _yRot;
	pfDCS * _dcs;

};

#endif

