/*************************************************************************
 **                           myPfWand.c++                              **
 *************************************************************************
 ** a small wand-pointer class                                          **
 ** along with virtually all other classes in this example, these were  **
 ** once CAVERNG2 enabled, so some of the functions are a bit strange   **
 ** since i stripped 90% of the code out of them.                       **
 *************************************************************************/
#include "myPfWand.h"

#include <Performer/pf/pfDCS.h>
#include <Performer/pf/pfTraverser.h>
#include <Performer/pfdu.h>
#include <pfcave.h>
#include <Performer/pf/pfGroup.h>
#include <Performer/pf/pfGeode.h>
#include <Performer/pr/pfGeoSet.h>

// this constructor gets used for our wand
myPfWand::myPfWand()
{
	long val = setSelfID();

	init(val);

}

myPfWand::~myPfWand()
{
	if (_dcs)
		pfDelete(_dcs);
}

void
myPfWand::init(long wID)
{
	_wandID = wID;

	int val = loadWandGeom(&(_dcs));

	if (!val)
		fprintf(stderr, "problem loading wand geometry\n");
}

long
myPfWand::setSelfID()
{
	return 3419026;  // in case you were wondering. 341-9026 was the phone
                     // number at the La Bianca home at 10050 Ciello DR
                     // where the La Bianca's and Sharon Tate were murdered.
                     // why do i know this?  'cause i was there.
}

int
myPfWand::loadWandGeom(pfDCS **dcs)
{
    pfNode *obj;
	pfFilePath("./geom/");

    if (obj = pfdLoadFile("wand.iv")) {
        (*dcs) = new pfDCS;
		// set travmask to mask out intersections with Wand geometry
        (*dcs)->setTravMask(PFTRAV_ISECT, 0x0, PFTRAV_SELF, PF_SET);

        (*dcs)->addChild(obj);

		return 1;
    } else
		return 0;

}

