/******************************************************************
 * appMain.c++                                                    *
 ******************************************************************/
#include <stdlib.h>
#include <strings.h>

#include <Performer/pf/pfChannel.h>
#include <Performer/pf/pfGroup.h>
#include <Performer/pf.h>
#include <Performer/pf/pfDCS.h>
#include <Performer/pfdu.h>
#include <pfcave.h>

#include "wandClientC.h"
#include "myPfWand.h"
#include "PSClass.h"

#include "cncreteMed.h"

int
main (int argc, char **argv)
{

	// PSClass creates a performer scene and does pfCAVE initialization.
	PSClass * psclassObj = new PSClass(argc, argv);
	psclassObj->configScene();

	pfScene * scene = psclassObj->getScene();
	// group is already parented to our current scene
	pfGroup *grp = psclassObj->getGroup();

	// instantiate wand container class
	wandClientC * wandCC = new wandClientC;
	wandCC->init(grp);
#if 0
	// add our wand to wandClientC.
	wandCC->add(new wdgPfWand());
#endif

	// add our wand DCS to pfScene
	grp->addChild(wandCC->getSelf()->getDCS());
	// create geometry pfDCS and child it to our pfGroup.
	pfDCS * gdcs = new pfDCS;
	grp->addChild(gdcs);

	// create our GUI concrete mediator
	cncreteMed * mediator = new cncreteMed(scene, gdcs);
	mediator->setWandDCS(wandCC->getSelf()->getDCS());

	int overM;
	while (!CAVEgetbutton(CAVE_ESCKEY))
	{
		wandCC->process(7);
		// performer graphics
		pfSync();
		pfCAVEPreFrame();
		pfFrame();
		pfCAVEPostFrame();

		// GUI. handleMenu() returns false if no widgets are intersected
		overM = mediator->handleMenu();

		if (mediator->getState() != mainInterfaceStateScope::PARENT)
		{
			// we're in either scale or trackball state
			// suspend action if we're intersecting the GUI
			if (!overM)
				mediator->geomManip();
		}

	}

	pfCAVEHalt();
	fprintf(stderr, "bye.\n");
	pfExit();

	return 0;
}

