/*************************************************************************
 **                           manipulator.h                             **
 *************************************************************************
 ** acts as a track-ball style manipulator for a DCS                    **
 ** places new DCS matrix values in CAVERN data key                     **
 ** Author: Fred Dech                                                   **
 ** (C) 1999 Virtual Reality in Medicine Laboratory                     **
 **          University of Illinois at Chicago                          **
 *************************************************************************/

#ifndef _manipulator_h_
#define _manipulator_h_

#include <Performer/pf.h>
#include <Performer/pf/pfDCS.h>
#include <sys/types.h>

#include <pfcave.h>

class manipulator
{
public:
	// constructor
	manipulator() : _dx(0.), _dy(0.), _dz(0.),
		_pickedDCS(NULL) { }

	// desctructor
	virtual ~manipulator() { }
	void listpfMatrix(pfMatrix *, const char *);

	void init(pfDCS *);
	pfMatrix * link();

private:
	void mtxCpy(float [4][4], pfMatrix *);
	void getWandMatrix(pfMatrix &);
	void getInverseWandMatrix(pfMatrix &);

	pfMatrix _grabMat, _newMat;
	float _dx, _dy, _dz;
	pfDCS * _pickedDCS;
};

#endif

