/**************************************************************************
 **                             myDefs.h                                 **
 **************************************************************************
 ** Enumerated types and defs for Widgets used in this application       **
 ** NOTE: not all Ident and State enums defined here are actually used   **
 ** by this example application.                                         **
 **************************************************************************/
#ifndef _myDefs_h_
#define _myDefs_h_

class mainInterfaceStateScope
{
public:
	enum mainInterfaceState {
		PARENT   = 0,
		MANIP    = 3,
		SCALE    = 5,
		NA       = -1
	};
};

typedef mainInterfaceStateScope::mainInterfaceState mainInterfaceState;

//-----------------------------------------------------------------------

// max number of buttonIdentTypes
static const int buttonIdentMax = 28;

class buttonIdentTypeScope
{
public:
	enum buttonIdentType {
		RESET        = 0,
		TWO          = 1,
		THREE        = 2,
		FOUR         = 3,
		FIVE         = 4,
		SIX          = 5,
		UNKNOWN      = 6,
		SEVEN        = 7,
		EIGHT        = 8,
		NINE         = 9,
		TEN          = 10,
		ELEVEN       = 11,
		TWELVE       = 12,
		THIRTEEN     = 13,
		FOURTEEN     = 14,
		FIFTEEN      = 15,
		SIXTEEN      = 16,
		SEVENTEEN    = 17,
		EIGHTEEN     = 18,
		NINETEEN     = 19,
		TWENTY       = 20,
		TWENTYONE    = 21,
		TWENTYTWO    = 22,
		MANIP        = 23,
		SCALE        = 24,
		NA           = -1
	};

};

typedef buttonIdentTypeScope::buttonIdentType buttonIdentType;

// these chars need to match the order of enums above
// they get used by the loader in cncreteMed and by the identifier in
// alphaObserv.
static const char _buttonIdentStr[buttonIdentMax][64] =
{
	"RESET",
	"TWO",
    "THREE",
	"FOUR",
	"FIVE",
	"SIX",
	"UNKNOWN",
	"SEVEN",
	"EIGHT",
	"NINE",
	"TEN",
	"ELEVEN",
	"TWELVE",
	"THIRTEEN",
	"FOURTEEN",
	"FIFTEEN",
	"SIXTEEN",
	"SEVENTEEN",
	"EIGHTEEN",
	"NINETEEN",
	"TWENTY",
	"TWENTYONE",
	"TWENTYTWO",
	"MANIP",
	"SCALE",
	"NA"
};

//-----------------------------------------------------------------------

// most if the stuff below is irrelevant


class mainInterfaceTypeScope
{
public:
	enum mainInterfaceType {
		MAIN_MENU           = 0,
		NOT_MAIN_MENU       = 1,
		STILL_NOT_MAIN_MENU = 2,
		NA                  = -1
	};
};

typedef mainInterfaceTypeScope::mainInterfaceType mainInterfaceType;

//-----------------------------------------------------------------------

class buttonInterfaceTypeScope
{
public:
	enum buttonInterfaceType {
		MAIN        = 0,
		NOT_MAIN    = 1,
		NOTNOT_MAIN = 2,
		NA          = -1
	};
};

typedef buttonInterfaceTypeScope::buttonInterfaceType buttonInterfaceType;

//-----------------------------------------------------------------------

class sliderInterfaceTypeScope
{
public:
	enum sliderInterfaceType {
		SLA         = 0,
		SLB         = 1,
		NA          = -1
	};
};

typedef sliderInterfaceTypeScope::sliderInterfaceType sliderInterfaceType;

//-----------------------------------------------------------------------

class sliderIdentTypeScope
{
public:
	enum sliderIdentType {
		DX          = 0,
		DY          = 1,
		DZ          = 2,
		SX          = 3,
		SY          = 4,
		SZ          = 5,
		C1          = 6,
		C2          = 7,
		L1          = 8,
		H1          = 9,
		L2          = 10,
		H2          = 11,
		NA          = -1
	};
};

typedef sliderIdentTypeScope::sliderIdentType sliderIdentType;

//-----------------------------------------------------------------------

class incrementorInterfaceTypeScope
{
public:
	enum incrementorInterfaceType {
		INC1         = 0,
		INC2         = 1,
		NA           = -1
	};
};

typedef incrementorInterfaceTypeScope::incrementorInterfaceType
        incrementorInterfaceType;

//-----------------------------------------------------------------------

class incrementorIdentTypeScope
{
public:
	enum incrementorIdentType {
		C        = 0,
		W        = 1,
		NA       = -1
	};
};

typedef incrementorIdentTypeScope::incrementorIdentType incrementorIdentType;


//-----------------------------------------------------------------------

#endif // #ifndef _myDefs_h_

