/*************************************************************************
 **                          mySlider.h                                 **
 *************************************************************************
 ** mySlider subclass of vwSlider                                       **
 ** with getInterface(), getIdent() overrides for app ID purposes.      **
 ** note that the Ident is of type buttonIdentType rather than          **
 ** sliderIdentType.  this is because this application is concerned with**
 ** who the parent of the slider is.  the parent is always a button.    **
 ** Author: Fred Dech                                                   **
 ** (C) 1999 Virtual Reality in Medicine Laboratory                     **
 **          University of Illinois at Chicago                          **
 *************************************************************************/

#ifndef _mySlider_h_
#define _mySlider_h_

#include <vwSlider.h>
#include <Performer/pr.h>

#include "myDefs.h"

class mySlider : public vwSlider
{
public:
	// constructor.
	mySlider(vwMediator *m, pfDCS *dcs) : vwSlider(m, dcs)
	{
		// this is a direct subclass of a generic widget
        // (i.e., vwButton, vwSlider, vwFrame, vwIncrementor)
		// vwWidget::_generic should be set to False.
		_generic = False;
	}

	// destructor
	virtual ~mySlider() { }

	inline void setInterface(sliderInterfaceType f)  { _sIface = f; }
	inline void setIdent(buttonIdentType f)          { _sIdent = f; }

	// override of vwWidget.
	inline int getInterface()          { return _sIface; }
	inline int getIdent()              { return _sIdent; }

private:
	buttonIdentType     _sIdent;
	sliderInterfaceType _sIface;

};

#endif

