/*************************************************************************
 **                         fancyCSlider.h                              **
 *************************************************************************
 ** fancyCSlideris meant as a center slider for a fancy interface.      **
 ** as an observer, it receives update events from vwIncrmtButton.      **
 ** Author: Fred Dech                                                   **
 ** (C) 1999 Virtual Reality in Medicine Laboratory                     **
 **          University of Illinois at Chicago                          **
 *************************************************************************/

#ifndef _fancyCSlider_h_
#define _fancyCSlider_h_

#include <Performer/pf/pfDCS.h>
#include <Performer/pf.h>

#include <dependents.h>
#include <vwSlider.h>

#include "myEnums.h"

class fancyCSlider : public vwSlider, public vwObserver
{
public:
	// constructor.
	fancyCSlider(vwMediator *, pfDCS *);

	// destructor
	virtual ~fancyCSlider() { }

	// declare update from abstract vwObserver pure virtual
	virtual void update(vwSubject *, void *);

	inline void setInterface(sliderInterfaceType f)  { _sIface = f; }
	inline void setIdent(sliderIdentType f)          { _sIdent = f; }

	// override of functions in vwWidget
	int getInterface()         { return _sIface; }
	int getIdent()             { return _sIdent; }


private:
	sliderInterfaceType      _sIface;     // slider interface ID
	sliderIdentType          _sIdent;     // specific slider ID

};

#endif

