/*************************************************************************
 **                        fancyFrame.c++                               **
 *************************************************************************
 ** fancyFrame changes colors when updated by vwButton.                 **
 ** Author: Fred Dech                                                   **
 ** (C) 2000 Virtual Reality in Medicine Laboratory                     **
 **          University of Illinois at Chicago                          **
 *************************************************************************/
#include "fancyFrame.h"

// constructor
fancyFrame::fancyFrame(vwMediator *m, pfSCS *scs, float *color) :
	vwFrame(m,scs), vwObserver(m)
{
	_generic = False;

	// set's activecolor to color
	registerColor(ACTIVE, color);
}

//constructor
fancyFrame::fancyFrame(vwMediator *m, pfSCS *scs) :
	vwFrame(m,scs), vwObserver(m)
{
	_generic = False;

	float c[4];

	getColor(OVERPRESSED, c);
	registerColor(ACTIVE, c);
}

// override of vwObserver::update() PV
void
fancyFrame::update(vwSubject *s, void *data)
{
	vwWidget *wdg = (vwWidget *) s;

	if (wdg->getPressed())
		setColor(ACTIVE);
	else
		setColor(INACTIVE);
}

