/*************************************************************************
 **                           fancyInc.h                                **
 *************************************************************************
 ** fancyInc is a special purpose vwIncremenntor                        **
 ** its designed exclusively for use with the fancy slider gui and keeps**
 ** track of things like Width and Center.                              **
 ** it's value can also be updated by a vwSubject it is attached to.    **
 ** Author: Fred Dech                                                   **
 ** (C) 1999 Virtual Reality in Medicine Laboratory                     **
 **          University of Illinois at Chicago                          **
 *************************************************************************/

#ifndef _fancyInc_h
#define _fancyInc_h

#include <vwIncrementor.h>

#include "myEnums.h"

class fancyInc : public vwIncrementor, public vwObserver
{
public:
	// constructor
	fancyInc(vwMediator *, pfSCS *, pfFont *);

	// destructor
	virtual ~fancyInc() { }

	inline void setInterface(incrementorInterfaceType f) { _iIface = f; }
	inline void setIdent(incrementorIdentType f) {
		_iIdent = f;
	}

	// override functions in vwWidget
	int getInterface() { return _iIface; }
	int getIdent()     { return _iIdent; }

	inline void setWidth(float w)      { _width = w; _center = -1.0; }
	inline void setCenter(float c)     { _center = c; _width = -1.0; }
	inline void setDataRange(float d)  { vwIncrementor::_dataRange = d; }
	inline void setGeomRange(float g)  { _geomRange = g; }
	inline void setGeomMin(float g)    { _geomMin = g;   }
	inline void setGeomMax(float g)    { _geomMax = g;   }
	inline float getWidth()            { return _width;  }
	inline float getCenter()           { return _center; }
	inline float getGeomWidth()        { return _geomWidth; }
	float getGeomVal();

	// override pure virtual vwObserver::update()
	void update(vwSubject *, void *);

	// override vwIncrementor::setValue()
	void setValue(float);

private:
	float _center, _width;
	float _geomWidth, _geomRange;
	float _geomCenter, _geomMin, _geomMax;

	// incrementor interface type
	incrementorInterfaceType _iIface;
	// incrementor ID
	incrementorIdentType     _iIdent;
};

#endif

