/*************************************************************************
 **                           fancyObserv.h                             **
 *************************************************************************
 ** This concrete Observer handles events from the fancy interface.     **
 ** Author: Fred Dech                                                   **
 ** (C) 2000 Virtual Reality in Medicine Laboratory                     **
 **          University of Illinois at Chicago                          **
 *************************************************************************/

#ifndef _fancyObserv_h_
#define _fancyObserv_h_

#include <Performer/pf.h>
#include <vwMediator.h>
#include <vwWidget.h>

#include "happySphere.h"

class fancyObserv : public vwObserver
{
protected:
	// constructor
	fancyObserv(vwMediator *);

public:
	// destructor
	virtual ~fancyObserv() { }

	// singleton method
	static fancyObserv * instance(vwMediator *);

	// override pure virtual from abstract vwObserver class
	void update(vwSubject *, void *);

	inline void getSliderLevelWidth(float *lev, float *wdth)
	{
		*lev = _level;
		*wdth = _width;
	}
	inline void getDataScaleRange(float *lo, float *hi)
	{
		*lo = _lo;
		*hi = _hi;
	}
	inline float getIncVal() { return _inc; }

private:
	static fancyObserv * _instance;

	happySphere * _sphere;

	float _level, _svlev;
	float _width, _svwid;
	float _lo, _hi;
	float _inc;

};

#endif

