/*************************************************************************
 **                           fancyWSlider.h                            **
 *************************************************************************
 ** fancyWSlider inherits publically from fancyCSlider.                 **
 ** fancyWSlider class works as the window-width upper or lower         **
 ** delimiting sliders for a fancy slider interface.  it receives       **
 ** update events from other fancyWSlider, fancyCSlider, fancyInc, and  **
 ** fancyButton.                                                        **
 ** Author: Fred Dech                                                   **
 ** (C) 1999 Virtual Reality in Medicine Laboratory                     **
 **          University of Illinois at Chicago                          **
 *************************************************************************/

#ifndef _fancyWSlider_h_
#define _fancyWSlider_h_

#include <Performer/pf/pfDCS.h>
#include <Performer/pf.h>

#include <vwSlider.h>
#include "fancyCSlider.h"

class fancyWSlider : public fancyCSlider
{
public:
	// constructor.
	fancyWSlider(vwMediator *, pfDCS *);

	// destructor
	virtual ~fancyWSlider() { }

	// sets up WSlider's parameters according to CSlider.
	void init(vwSlider *);

	// override of fancyCSlider::update()
	void update(vwSubject *, void *);

	void setSide(int, float datawidth);
	// overload to accomodate remote client driven drag.
	void setSide(int, float datawidth, int eventVal);

	inline float getDataWidth()            { return _dataWidth; }
	inline float getGeomWidth()            { return _geomWidth; }

	// to completely clear and setup the slider with its center slider
	void reset(vwSlider *s) {
		init(s);
		setSide(getIdent(), 0.0);
	}

private:
	float _dataCenter;
	float _geomCenter;
	float _dataWidth;
	float _geomWidth;

	// override vwSlider::applyDrag()
	void applyDrag(float [], int);
};

#endif

