/*************************************************************************
 **                        myPushButton.h                               **
 *************************************************************************
 ** myPushButton subclass of vwPushButton.                              **
 ** simply changes between two states                                   **
 ** getIdent().  getInterface() ovverides for ID purposes in app        **
 ** Author: Fred Dech                                                   **
 ** (C) 2001 Virtual Reality in Medicine Laboratory                     **
 **          University of Illinois at Chicago                          **
 *************************************************************************/

#ifndef _myPushButton_h_
#define _myPushButton_h_

#include <vwPushButton.h>

#include "myEnums.h"

class myPushButton : public vwPushButton
{
public:
	// constructor.
	myPushButton(vwMediator *m, pfDCS * dcs) :
	     vwPushButton(m,dcs)
	{ }

	virtual ~myPushButton() { }

	inline void setInterface(buttonInterfaceType f) { _bIface = f; }
	inline void setIdent(buttonIdentType f)         { _bIdent = f; }

	// override vwWidget functions
	inline int getInterface()           { return _bIface; }
	inline int getIdent()               { return _bIdent; }

private:
	buttonIdentType     _bIdent;     // button ID
	buttonInterfaceType _bIface;     // button interface ID

};

#endif

