/*************************************************************************
 **                        myRadioButton.h                              **
 *************************************************************************
 ** myRadioButton is a special-purpose subclass of vwRadioButton.       **
 ** allows it to make its special-purpose identity known via            **
 ** getInterface().  getIdent() ovverides for app ID purposes.          **
 ** Author: Fred Dech                                                   **
 ** (C) 2000 Virtual Reality in Medicine Laboratory                     **
 **          University of Illinois at Chicago                          **
 *************************************************************************/

#ifndef _myRadioButton_h_
#define _myRadioButton_h_

#include <vwRadioButton.h>

#include "myEnums.h"

class myRadioButton : public vwRadioButton
{
public:
	// constructor.
	myRadioButton(vwMediator *m, pfDCS * dcs) :
	  vwRadioButton(m,dcs), _bIface(buttonInterfaceTypeScope::MAIN)
	{ }

	virtual ~myRadioButton() { }

	inline void setInterface(buttonInterfaceType f) { _bIface = f; }
	inline void setIdent(buttonIdentType f)         { _bIdent = f; }

	// override vwWidget functions
	inline int getInterface()          { return _bIface; }
	inline int getIdent()              { return _bIdent; }

private:
	buttonIdentType     _bIdent;     // button ID
	buttonInterfaceType _bIface;     // button interface ID

};

#endif

