/*************************************************************************
 **                        wandClientC.h                                **
 *************************************************************************
 ** a simple wand CAVERNsoft Client container class.                    **
 *************************************************************************/

#ifndef _wandClientC_h_
#define _wandClientC_h_

#include <Performer/pf/pfDCS.h>

#include "myPfWand.h"

static const int _WAND_CONT_MAX_CLIENTS = 5;

// wand diffuse and specular colors
static float wandDiffuse[_WAND_CONT_MAX_CLIENTS][3] = 
{
  1.00, 0.00, 0.00,
  0.00, 1.00, 0.00,
  0.75, 0.75, 0.00,
  0.00, 0.50, 0.95,
  0.65, 0.00, 0.40
};
// wand ambiend colors
static float wandAmbient[_WAND_CONT_MAX_CLIENTS][3] = 
{
  0.45, 0.00, 0.85,
  0.00, 0.20, 0.50,
  0.65, 0.35, 0.00,
  0.00, 0.50, 0.25,
  0.05, 0.70, 0.00
};

class wandClientC
{
public:
	// constructor
	wandClientC() :
		_wandCount(0), _selfWand(NULL), _wccGroup(NULL)
	{ }

	// destructor
	~wandClientC();

	int init(pfGroup * g);

	void add(myPfWand *);
	int remove(int i);
	int remove(long id);

	inline myPfWand * getSelf()   { return _selfWand; }

	inline myPfWand * retrieve(int i)
	{
		if (i >= 0 && i < _wandCount)
			return w[i];
		else
			return NULL;
	}
	inline myPfWand * retrieve(long id)
	{
		for (int ii=0; ii< _wandCount; ii++) {
			if (w[ii] && id == w[ii]->getID())
				return w[ii];
		}
		return NULL;
	}
	void updateSelf();
	void process(int iter=5);

	inline int getCount() const { return _wandCount; }


private:
	int _wandCount;
	int changeWandColor(pfNode *, float *, float *);

	myPfWand * w[_WAND_CONT_MAX_CLIENTS];
	myPfWand * _selfWand;
	pfGroup * _wccGroup;

};

#endif

